<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                  version="1.0">

   <!-- Declare the filteredColumn parameter-->
   <xsl:param name='filteredColumn'/>

   <!-- Generate HTML for the document root -->
   <xsl:template match='/'>
      <table border='1'>
         <tr>
            <th>First Name</th>
            <th>Last Name</th>
            <th>Company</th>

            <xsl:if test='$filteredColumn != "email"'>
               <th>Email</th>   
            </xsl:if>

            <xsl:if test='$filteredColumn != "phone@work"'>
               <th>Work Phone</th>
            </xsl:if>

            <xsl:if test='$filteredColumn != "phone@home"'>
               <th>Home Phone</th>
            </xsl:if>

            <xsl:apply-templates/>
         </tr>
      </table>
   </xsl:template>

   <!-- Create a table row for each item and apply templates -->
   <xsl:template match='contact'>
      <tr><xsl:apply-templates/></tr>
   </xsl:template>

   <!-- Create table data for each item's children and 
        apply templates -->
   <xsl:template match='contact/*'>
      <td><xsl:apply-templates/></td>
   </xsl:template>
</xsl:stylesheet>
