<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                  version="1.0">

   <!-- Declare the filteredColumn parameter-->
   <xsl:param name='filteredColumn'/>

   <!-- Generate HTML for the document root -->
   <xsl:template match='/'>
      <table border='1'>
         <tr>
            <th>First Name</th>
            <th>Last Name</th>
            <th>Company</th>

            <xsl:if test='$filteredColumn != "email"'>
               <th>Email</th>   
            </xsl:if>

            <xsl:if test='$filteredColumn != "phone@work"'>
               <th>Work Phone</th>
            </xsl:if>

            <xsl:if test='$filteredColumn != "phone@home"'>
               <th>Home Phone</th>
            </xsl:if>

            <xsl:apply-templates/>
         </tr>
      </table>
   </xsl:template>

   <!-- Create a table row for each item and apply templates -->
   <xsl:template match='contact'>
      <tr><xsl:apply-templates/></tr>
   </xsl:template>

   <!-- Create table data for all elements that are children
        of contact elements, except for home and work phone, which
        are processed below -->
   <xsl:template match='contact/*'>
      <xsl:if test='$filteredColumn != local-name()'>
         <td><xsl:apply-templates/></td>
      </xsl:if>   
   </xsl:template>

   <!-- Create table data for the Work Phone element -->
   <xsl:template match='contact/phone[@type="work"]'>
      <xsl:if test='$filteredColumn != "phone@work"'>
         <td><xsl:apply-templates/></td>
      </xsl:if>   
   </xsl:template>

   <!-- Create table data for the Home Phone element -->
   <xsl:template match='contact/phone[@type="home"]'>
      <xsl:if test='$filteredColumn != "phone@home"'>
         <td><xsl:apply-templates/></td>
      </xsl:if>   
   </xsl:template>
</xsl:stylesheet>
