<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Parsing XML</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ taglib uri='http://java.sun.com/jstl/xml'  prefix='x' %>

      <%-- Import the XML file --%>
      <c:import var='rolodex_xml' url='rolodex.xml'/>

      <%-- Parse the XML file --%>
      <x:parse var='document' xml='${rolodex_xml}'/>

      <p>There are 
         <x:out select='count($document//contact)'/>
         contacts in the rolodex.<p>

      <x:out 
         select='count($document//contact/phone[@type="work"])'/>
      of those contacts have a work phone number and 
      <x:out 
         select='count($document//contact/phone[@type="home"])'/>
      of those contacts have a home phone number.<p>

      <%-- For each contact in the rolodex... --%>
      <x:forEach select='$document//contact'>
         <table>
            <tr>
               <td>First Name:</td>
               <td><x:out select='firstName'/></td>
            </tr>

            <tr>
               <td>Last Name:</td>
               <td><x:out select='lastName'/></td>
            </tr>

            <tr>
               <td>Email:</td>
               <td><x:out select='email'/></td>
            </tr>

            <tr>
               <td>Work Phone:</td>
               <td><x:out select='phone[@type="work"]'/></td>
            </tr>

            <%-- Home phone is optional, so we check to see
                 if it exists before processing it --%>
            <x:if select='phone[@type="home"]'>
               <tr>
                  <td>Home Phone:</td>
                  <td><x:out select='phone[@type="home"]'/></td>
               </tr>
            </x:if>
         </table><p>
      </x:forEach>
   </body>
</html>
