<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ taglib uri='http://java.sun.com/jstl/xml'  prefix='x' %>
      <title>Using Scoped Variables with XPath</title>
   </head>

   <body>
      <%-- Import the phone book XML file --%>
      <c:import var='rolodex_xml' url='rolodex.xml'/>

      <%-- Parse the phone book XML file --%>
      <x:parse var='document' xml='${rolodex_xml}'/>

      <%-- For each address --%>
      <x:forEach select='$document//contact'>
         <%-- If this contact's work phone starts with the
              specified area code, show contact information --%>
         <x:if 
         select='starts-with(phone[@type="work"],$param:areaCode)'>
            <table>
               <tr>
                  <td>First Name:</td>
                   <td><x:out select='firstName'/></td>
               </tr>

               <tr>
                  <td>Last Name:</td>
                   <td><x:out select='lastName'/></td>
               </tr>

               <tr>
                  <td>Email:</td>
                   <td><x:out select='email'/></td>
               </tr>

               <tr>
                  <td>Work Phone:</td>
                   <td><x:out select='phone[@type="work"]'/></td>
               </tr>

               <%-- Home phone number is optional, so we check
                    to see if it exists before creating a table
                    row --%>
               <x:if select='phone[@type="home"]'>
                  <tr>
                     <td>Home Phone:</td>
                     <td><x:out select='phone[@type="home"]'/></td>
                  </tr>
               </x:if>
            </table><br>
         </x:if>
      </x:forEach>
   </body>
</html>
