import java.io.IOException;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import beans.*;

public class DataCreatorServlet extends HttpServlet {
   public void doGet(HttpServletRequest request,
                     HttpServletResponse response)
                     throws IOException, ServletException {
      // Create an array, map, and list
      UserProfile[] profileArray = createProfiles();
      HashMap         profileMap = new HashMap();
      LinkedList     profileList = new LinkedList();

      // Populate the list and map
      for(int i=0; i < profileArray.length; ++i) {
         UserProfile profile = profileArray[i];

         profileList.add(profile);

         String firstName = profile.getName().getFirstName(),
                 lastName = profile.getName().getLastName(),
                      key = firstName + " " + lastName;

         profileMap.put(key, profile);
      }

      // Store the array, map, and list in request scope
      request.setAttribute("profileArray", profileArray);
      request.setAttribute("profileMap",   profileMap);
      request.setAttribute("profileList",  profileList);

      // Forward the request and response to /showData.jsp
      RequestDispatcher rd = 
         getServletContext().getRequestDispatcher("/showData.jsp");

      rd.forward(request, response);
   }
   private UserProfile[] createProfiles() {
      // Create an array of user profiles
      UserProfile[] userProfiles = {
         new UserProfile(new Name("James", "Wilson"),
                          new Address("102 Oak St.", "Buffalo", 
                                      "New York", 14214)),
         new UserProfile(new Name("Cindy", "Smith"),
                          new Address("29419 Genessee St.", 
                                      "Buffalo", "New York", 14214))
      };
      return userProfiles;
   }
}
