<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Accessing Beans with the EL</title>
   </head>
   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>

      <%-- Create a Name bean and store it in page scope --%>
      <jsp:useBean id='name' class='beans.Name'>
         <%-- Set properties with strings --%>
         <jsp:setProperty name='name' 
                      property='firstName' value='Claude'/>
         <jsp:setProperty name='name' 
                      property='lastName'  value='Loubier'/>
      </jsp:useBean>

      <%-- Create an Address bean and store it in page scope --%>
      <jsp:useBean id='address' class='beans.Address'> 
         <%-- Set properties with strings --%>
         <jsp:setProperty name='address' 
                      property='streetAddress' 
                        value='119342 North Maison'/>
         <jsp:setProperty name='address' 
                      property='city'  value='Buffalo'/>
         <jsp:setProperty name='address' 
                      property='state' value='New York'/>
         <jsp:setProperty name='address' 
                      property='zip'   value='14214'/>
      </jsp:useBean>

      <%-- Create a UserProfile bean and store it in 
           page scope --%>
      <jsp:useBean id='profile' 
                class='beans.UserProfile'> 
         <%-- Set properties with the name bean and address
              bean stored in page scope --%>
         <jsp:setProperty name='profile' 
            property='name'
               value='<%= (beans.Name)
                          pageContext.getAttribute("name") %>'/>

         <jsp:setProperty name='profile' 
            property='address' 
               value='<%= (beans.Address)
                          pageContext.getAttribute("address") %>'/>
      </jsp:useBean>

      <%-- Show profile information --%>

      Profile for 
      <%-- Access the name bean's firstName property directly, 
           without specifying scope --%>
      <c:out value='${name["firstName"]}'/>

      <%-- Access the name bean's lastName property through the 
           profile bean by explicitly specifying scope --%>
      <c:out value='${pageScope.profile.name.lastName}'/>:
      <p>
      <table>
         <tr>
            <%-- Access the UserProfile bean's properties without
                 explicitly specifying scope --%>
            <td>First Name:</td>
            <td><c:out value='${profile["name"].firstName}'/></td>
         </tr><tr>
            <td>Last Name:
            <td><c:out value='${profile.name["lastName"]}'/></td>
         </tr><tr>
            <td>Street Address:
            <td><c:out value='${profile.address.streetAddress}'/>
            </td>
         </tr><tr>
            <td>City:
            <td><c:out value='${profile.address.city}'/></td>
         </tr><tr>
            <td>State:
            <td><c:out value='${profile.address.state}'/></td>
         </tr><tr>
            <td>Zip Code:
            <td><c:out value='${profile.address.zip}'/></td>
         </tr>
      </table>
   </body>
</html>
