<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Set Color Preferences</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>

      <c:choose>
         <%-- If there's an error message about a bad color 
              combination... --%>
        <c:when test='${not empty sessionScope.colorErrorMessage}'>
            <%-- ...set the font size and color,... --%>
            <font size='4' color='red'>
              <%-- ...display the error message and... --%>
              <c:out value='${sessionScope.colorErrorMessage}'/><p>
            </font>

            <%-- ...remove the error message from session scope.
                 Note: it's not necessary to specify the scope
                 attribute for <c:remove>, but it's good 
                 practice. --%>
            <c:remove var='colorErrorMessage' scope='session'/>
         </c:when>

         <%-- If there's not an error message about a bad color 
              combination, ask the user to set colors --%>
         <c:otherwise>
            Please set your background and foreground colors:
         </c:otherwise>
      </c:choose>

      <%-- Store the preferred colors stored in the color
           preferences bean in page scope variables, for better
           readability in the <c:if> actions used for the HTML
           options below --%>
      <c:set var='prefBgColor' 
           value='${sessionScope.bean.background}'/>

      <c:set var='prefFgColor' 
           value='${sessionScope.bean.foreground}'/>

      <%-- The form --%>
      <p><form action='welcome.jsp'>
         <table>
            <tr>
               <td>Background Color:</td>
               <td>
                  <%-- Create the HTML select element for 
                       background color --%>
                  <select name='bgcolor'>
                     <%-- Create option elements and select the
                          previously selected background color --%>
                     <option value='white' 
                        <c:if test='${prefBgColor == "white"}'>
                           selected
                        </c:if>
                        >white</option>
                     <option value='yellow' 
                        <c:if test='${prefBgColor == "yellow"}'>
                           selected
                        </c:if>
                        >yellow</option>
                     <option value='black' 
                        <c:if test='${prefBgColor == "black"}'>
                           selected
                        </c:if>
                        >black</option>
                     <option value='blue' 
                        <c:if test='${prefBgColor == "blue"}'>
                           selected
                        </c:if>
                        >blue</option>
                  </select>
               </td>
            </tr>

            <tr>
               <td>Foreground Color:</td>
               <td>
                  <%-- Create the HTML select element for 
                       foreground color --%>
                  <select name='fgcolor'>
                     <%-- Create option elements and select the
                          previously selected foreground color --%>
                     <option value='white' 
                        <c:if test='${prefFgColor == "white"}'>
                           selected
                        </c:if>
                        >white</option>
                     <option value='yellow' 
                        <c:if test='${prefFgColor == "yellow"}'>
                           selected
                        </c:if>
                        >yellow</option>
                     <option value='black' 
                        <c:if test='${prefFgColor == "black"}'>
                           selected
                        </c:if>
                        >black</option>
                     <option value='blue' 
                        <c:if test='${prefFgColor == "blue"}'>
                           selected
                        </c:if>
                        >blue</option>
                  </select>
               </td>
            </tr>
         </table>

         <%-- Create the submit button text, using the name of the
              last page stored in session scope --%>
         <c:set var='submitButtonText'>
            Return to <c:out value='${sessionScope.lastPage}'/> 
         </c:set>

         <%-- Create the submit button, using the value of the
              page-scoped variable created above as the 
              button's text --%>
         <p><input type='submit' 
                  value='<c:out value="${submitButtonText}"/>'/>
      </form>
   </body>
</html>
