<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <%-- The taglib declaration is in the <head> section because
           <c:out> is used by the <body> element below --%>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'%>

      <title>Welcome to core-jstl.com</title>
   </head>

   <%-- Specify a background color for the body that matches the
        bgcolor request parameter --%>
   <body bgcolor='<c:out value="${param.bgcolor}"/>'>

      <%-- Store the name of this page in a session-scoped 
           variable. That variable is used below to generate an 
           error message and in set_colors.jsp to set the 
           submit button's text --%>
      <c:set var='lastPage' scope='session' value='core-jstl.com'/>

      <%-- If request parameters for foreground and background
           colors exist... --%>
    <c:if test='${! empty param.fgcolor && ! empty param.bgcolor}'>

         <%-- ...create a color preferences bean and store it in
                 session scope so that those color preferences can
                 be used by other JSP pages in the application --%>
         <jsp:useBean id='bean' scope='session' 
                   class='beans.ColorPreferences'/>

         <%--    Set the bean's background property to the
                 background color specified with the bgcolor
                 request parameter and... --%>
         <c:set target='${bean}' property='background'
                 value='${param.bgcolor}'/>

         <%-- ...set the bean's foreground property to the
                 foreground color specified with the fgcolor --%>
         <c:set target='${bean}' property='foreground'
                 value='${param.fgcolor}'/>

         <%-- If the bean's foreground and background colors 
              are the same... --%>
         <c:if test='${bean.background == bean.foreground}'>
            <%-- ...store an error message in session scope 
                 and...--%>
            <c:set var='colorErrorMessage' scope='session'>
               Sorry, but you can't specify the same colors for the
               foreground and background because you won't 
               be able to see anything at 
               <c:out value='${sessionScope.lastPage}'/>
            </c:set>

            <%-- ...go back to set_colors.jsp --%>
            <jsp:forward page='set_colors.jsp'/>
         </c:if>
      </c:if>

      <%-- Set font characteristics --%>
      <font size='6' face='Arial,Helvetica' 
           color='<c:out value="${bean.foreground}"/>'/>
         Welcome to core-jstl.com
      </font>

      <hr><p>

      <%-- Reset font size --%>
      <font color='<c:out value="${bean.foreground}"/>'/>
         <i>Core JSTL</i> is an in-depth examination of the 
         JavaServer Pages Standard Tag Library (JSTL), which 
         provides a standard set of custom tags including:
         <ul>
            <li>General Purpose Actions
            <li>Conditional and Iteration Actions
            <li>URL Actions
            <li>Database Actions
            <li>Internationalization Actions
            <li>XML Actions
         </ul>
      
         <hr>
         Click <a href='set_colors.jsp'>here</a> to change your
         color preferences.
      </font>
   </body>
</html>
