package tags;

import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.jstl.core.ConditionalTagSupport;
import beans.ColorPreferences;

public class IfBadColorCombinationAction 
             extends ConditionalTagSupport {
   private String targetName;

   // Setter method for the target attribute, which is a string
   public void setTarget(String targetName) {
      this.targetName = targetName;   
   }

   // Compare bean colors and return true if it's a bad 
   // combination; otherwise, return false
   protected boolean condition() throws JspTagException {
      ColorPreferences bean = (ColorPreferences)
                              pageContext.findAttribute(targetName);

      return bean.getBackground().equals(bean.getForeground());   
   }
}
