<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'%>

      <title>Welcome to core-jstl.com</title>
   </head>

   <body bgcolor='<c:out value="${param.bgcolor}"/>'>
      <%@ taglib uri='WEB-INF/app-tlds/app.tld' 
              prefix='core-jstl'%>

      <%-- Store the name of this page in a session-scoped variable.
           That variable is used below and in set_colors.jsp. --%>
      <c:set var='lastPage' scope='session' value='core-jstl.com'/>

      <%-- If request parameters for foreground and background
           colors exist... --%>
      <c:if test='${not empty param.fgcolor and
                    not empty param.bgcolor}'>

         <%-- ...create a color preferences bean, store it in
                 session scope and... --%>
         <jsp:useBean id='bean' scope='session' 
                   class='beans.ColorPreferences'/>

         <%-- ...set the bean's background property to the
                 background color specified with the bgcolor
                 request parameter and... --%>
         <c:set target='${bean}' property='background'
                 value='${param.bgcolor}'/>

         <%-- ...set the bean's foreground property to the
                 foreground color specified with the fgcolor --%>
         <c:set target='${bean}' property='foreground'
                 value='${param.fgcolor}'/>

         <%-- If the foreground and background colors were set
              to the same value... --%>
         <%--
         <c:if test='${bean.background == bean.foreground}'>
         <core-jstl:ifBadColorCombination target='bean'>
         --%>
         <core-jstl:ifBadColorCombination target='bean'
                                             var='badColorCombo'
                                           scope='page'/>
            <c:if test='${badColorCombo}'>
               <%-- ...store an error message in 
                         session scope and...--%>
               <c:set var='colorErrorMessage' scope='session'>
                  Sorry, but you can't specify the same colors for 
                  foreground and background colors because you won't
                  be able to see anything at 
                  <c:out value='${sessionScope.lastPage}'/>
               </c:set>

               <%-- ...go back to set_colors.jsp --%>
               <jsp:forward page='set_colors.jsp'/>
            </c:if>
         </core-jstl:ifBadColorCombination> 
      </c:if>

      <%-- Set font characteristics --%>
      <font size='6' face='Arial,Helvetica' 
           color='<c:out value="${param.fgcolor}"/>'/>
         Welcome to core-jstl.com
      </font>

      <hr><p>

      <%-- Reset font characteristics --%>
      <font color='<c:out value="${param.fgcolor}"/>'/>
         Core JSTL is an in-depth examination of the JavaServer 
         Pages Standard Tag Library (JSTL), which provides a 
         standard set of custom tags including:
         <ul>
            <li>General Purpose Actions
            <li>Conditional and Iteration actions
            <li>URL Access
            <li>Database Access
            <li>Internationalization
            <li>Manipulation and Transformation of XML Documents
         </ul>
      
         <hr>
         Click <a href='set_colors.jsp'>here</a> to change colors 
         on this page.
      </font>
   </body>
</html>
