<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Set Bean Properties</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>

      <%-- Create a color preferences bean and store it in
           page scope --%>
      <jsp:useBean id='bean' class='beans.ColorPreferences'/>

      <%-- If there are no bgcolor or fgcolor request parameters
           (as is the case when this page is first loaded), 
           the following <c:set> actions set the bean's 
           properties to null --%>

      <%-- Set the bean's background property to the value of the 
           bgcolor request parameter --%>
      <c:set target='${bean}' property='background' 
              value='${param.bgcolor}'/>

      <%-- Set the bean's foreground property to the value of the 
           fgcolor request parameter. Notice that the action's
           value is specified in the body of the action, for no
           other reason than to show it can be done. --%>
      <c:set target='${bean}' property='foreground'>
         <c:out value='${param.fgcolor}'/>
      </c:set>

      <table align='center'>
         <tr>
            <td colspan='2' align='center'></td>
               <%-- Create a table with the background color 
               stored in the bean's background property --%>
               <table border='3' align='center'
                     bgcolor='<c:out value="${bean.background}"/>'>
                  <tr>
                     <td>
                     <%-- Create table data with the font color 
                          stored in the bean's foreground 
                          property --%>
                     <font size='7'
                       color='<c:out value="${bean.foreground}"/>'>
                        JSTL
                     </font>
                     </td>
                  </tr>
               </table><p>
            </td>
         </tr>

         <tr>
            <%-- Because the following form has no action, this JSP
                 page will be reloaded when the form 
                 is submitted --%>
            <form>
               <table align='center'>
                  <tr>
                     <td>Background Color:</td>
                     <td>
                        <%-- Create the HTML select element for 
                               background color --%>
                        <select name='bgcolor'>
                           <option value='white'>white</option> 
                           <option value='black'>black</option> 
                        </select>
                     </td>
                  </tr>

                  <tr>
                     <td>Foreground Color:</td>
                     <td>
                        <%-- Create the HTML select element for 
                             foreground color --%>
                        <select name='fgcolor'>
                           <option value='white'>white</option> 
                           <option value='black'>black</option> 
                        </select>
                     </td>
                  </tr>

                  <tr>
                     <table align='center'>
                        <tr>   
                           <td><input type='submit'></td> 
                        </tr>   
                     </table>
                  </tr>
               </table>
            </form>
         </tr>
      </table>
   </body>
</html>
