<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Add and Remove Entries in a Map</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>

      <%-- Create a hash map and store it in session scope --%>
      <jsp:useBean id='map' class='java.util.HashMap'
                            scope='session'>
         <%-- Add initial key/value pairs stored in the hash
              map. The following <c:set> actions are only invoked
              when the hash map is created. --%>
         <c:set target='${map}' property='inline skates' 
                                   value='149.99'/>
         <c:set target='${map}' property='hockey stick' 
                                   value='29.99'/>
         <c:set target='${map}' property='elbow pads'  
                                   value='19.99'/>
         <c:set target='${map}' property='puck' 
                                   value='5.99'/>
      </jsp:useBean>

      <%-- Add an entry to the map, modify an existing entry,
           or remove an entry, all with the following <c:set>
           action, depending on the values of the key and
           value request parameters. Those request parameters
           are set by add.jsp and remove.jsp, which are invoked
           depending on which button is selected from this
           page. --%>
      <c:set target='${map}' 
           property='${param.key}' value='${param.value}'/>

      <table border='1'>
         <tr>
            <th>Item</th>
            <th>Price</th>
         </tr>

         <%-- Use <c:forEach> to create an HTML table that shows
              the map entries --%>
         <c:forEach var='entry' items='${map}'>
            <tr>
               <td><c:out value='${entry.key}'/></td>
               <td><c:out value='${entry.value}'/></td>
            </tr>
         </c:forEach>
      </table>

      <form action='add.jsp'>
         <input type='submit' value='Add or Modify an Item'/>
      </form>

      <form action='remove.jsp'>
         <input type='submit' value='Remove an Item'/>
      </form>
   </body>
</html>
