<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Testing Iteration Custom Actions</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'  %>
      <%@ taglib uri='WEB-INF/core-jstl.tld' prefix='core-jstl'%>

      <% // This string, which could ultimately come from a data 
         // source such as a flat file, could be stored in 
         // request scope (or any other scope) by a business 
         // component. The page author just needs to know the 
         // name of the corresponding scoped variable and 
         // the delimiters.
  
         // The first token delimited with the characters []
         // represents table column names. The rest of the tokens
         // represent table data.

         String s = "[Name, Age, Sex, Street Address]"           +
                  "[Phyllis Keeney, 62, Female,123 Cherry Lane]" +
                  "[George Wilson, 24, Male, 16 Rue Florence]"   +
                  "[Lynn Seckinger, 36, Female, 2096 Oak St]"    +
                  "[Roy Martin, 44, Male, 29419 112th Ave]"      +
                  "[William Bates, 96, Male, 800 Birch St]"      +
                  "[Kathy Giuseppi, 13, Female, 1245 Genesee St]";

         // Store the string in page scope
         pageContext.setAttribute("dataForSimpleTable", s); 
      %>

      <p><table border='1'>
         <%-- For each token in the string delimited with [] --%>
         <c:forTokens var='tableData' delims='[]'
                    items='${dataForSimpleTable}'>

            <%-- This custom action includes its body content if
                 it's the first round of the iteration --%>
            <core-jstl:firstRound>
               <tr>
                  <c:forEach var='tableHeader' 
                           items='${tableData}'>
                     <th><c:out value='${tableHeader}'/></th>
                  </c:forEach>
               </tr>
            </core-jstl:firstRound>

            <%-- This custom action includes its body content if
                 it's NOT the first round of the iteration --%>
            <core-jstl:notFirstRound>
               <tr>
                  <c:forEach var='rowData' items='${tableData}'>
                     <td><c:out value='${rowData}'/></td>
                  </c:forEach>
               </tr>
            </core-jstl:notFirstRound>
         </c:forTokens>
      </table>
   </body>
</html>
