<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>
         Iteration Status for Iterating Over Integer Values
      </title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>

      <%-- Because this form does not specify an action, this
           JSP page will be reloaded when the submit button
           is activated --%>
      <form>
         <table>
            <tr>
               <td>Begin:</td>
               <td><input type='text' size='3' 
                         value='<c:out value="${param.begin}"/>'
                          name='begin'/></td>
               <td>End:</td>
               <td><input type='text' size='3'
                         value='<c:out value="${param.end}"/>'
                          name='end'/></td>
               <td>Step:</td>
               <td><input type='text' size='3'
                         value='<c:out value="${param.step}"/>'
                          name='step'/></td>
            </tr>
         </table>

         <p><input type='submit' value='Iterate Now'/>
      </form>
      
      <c:if test='${not empty param.begin and 
                    not empty param.end and 
                    not empty param.step}'>
         <table border='1'>
            <tr>
               <%-- Create table headers --%>
               <c:forEach var='item' items='Current,Index,Count,
                                            Is First,Is Last,
                                            Begin,End,Step'>
                  <th><c:out value='${item}'/></th>
               </c:forEach>
            </tr>
         
            <%-- Loop over numeric values specified with 
                 request parameters --%>
            <c:catch var='exception'>
               <c:forEach varStatus='status'
                              begin='${param.begin}'
                                end='${param.end}'
                               step='${param.step}'>
                  <tr>
                     <%-- Create table data --%>
                     <td><c:out value='${status.current}'/></td>
                     <td><c:out value='${status.index}'/></td>
                     <td><c:out value='${status.count}'/></td>
                     <td><c:out value='${status.first}'/></td>
                     <td><c:out value='${status.last}'/></td>
                     <td><c:out value='${status.begin}'/></td>
                     <td><c:out value='${status.end}'/></td>
                     <td><c:out value='${status.step}'/></td>
                  </tr>
               </c:forEach>
            </c:catch>
         </table>
      </c:if>

      <%-- Handle exceptions thrown by <c:forEach> --%>
      <c:if test='${not empty exception}'>
         <font color='red'>
            Iteration failed because<i> 
            <c:out value='${exception.message}'/></i>
         </font>
      </c:if>
   </body>
</html>
