<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Iterating Over Strings</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>

      Build a Table from a Single String!
      <% 
         // This string, which could ultimately come from a data 
         // source such as a flat file, could be stored in 
         // request scope (or any other scope) by a business 
         // component. The page author just needs to know the 
         // name of the corresponding scoped variable and 
         // the delimiters.
  
         // The first token delimited with the characters []
         // represents table column names. The rest of the tokens
         // represent table data.

         String s = "[Name, Age, Sex, Street Address]" +
              "[Phyllis Keeney, 62, Female,123 Cherry Lane]" +
              "[George Wilson, 24, Male, 16 Rue Florence]" +
              "[Lynn Seckinger, 36, Female, 2096 Oak St]" +
              "[Roy Martin, 44, Male, 29419 112th Ave]" +
              "[William Bates, 96, Male, 800 Birch St]" +
              "[Kathy Giuseppi, 13, Female, 1245 Genesee St]";

         // Store the string in request scope
         pageContext.setAttribute("dataForSimpleTable", s,
                                   PageContext.REQUEST_SCOPE);
      %>

      <%-- Create the HTML table with <c:forTokens> and 
           <c:forEach> --%>

      <p><table border='1'>
         <c:forTokens var='tableData' varStatus='status'
                    items='${dataForSimpleTable}'
                   delims='[]'>

            <c:choose>
               <%-- If it's the first token, create the 
                      table headers --%>
               <c:when test='${status.first}'>
                  <tr>
                     <%-- Instead of <c:forEach> we could've used 
                            <c:forTokens> with commas for delimiters,
                          as we do below --%>
                     <c:forEach var='tableHeader' 
                              items='${tableData}'>
                        <th><c:out value='${tableHeader}'/></th>
                     </c:forEach>
                  </tr>
               </c:when>

               <%-- If it's not the first token, create the
                    table rows --%>
               <c:otherwise>
                  <tr>
                     <%-- Instead of <c:forTokens> with commas for
                          delimiters, we could've used 
                          <c:forEach>, as we did above --%>
                     <c:forTokens var='rowData' 
                                items='${tableData}'
                               delims=','>
                        <td><c:out value='${rowData}'/>
                     </c:forTokens>
                  </tr>
               </c:otherwise>
            </c:choose>
         </c:forTokens>
      </table>
   </body>
</html>
