<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Iterating Over A Vector</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ page import='java.util.Vector' %>

      <% // Create a vector of strings
         Vector v= new Vector();
         v.add("ONE");   v.add("TWO");   v.add("THREE"); 
         v.add("FOUR");  v.add("FIVE");  v.add("SIX");
         v.add("SEVEN"); v.add("EIGHT"); v.add("NINE"); 
         v.add("TEN"); 

         // Store the vector in page scope
         pageContext.setAttribute("vector", v);
      %>
      <%-- Loop over a vector with looping attributes specified 
           with request parameters --%>
      <c:catch var='exception'>
         Iterating over a vector:
         <c:forEach items='${vector}'
                      var='item' begin='${param.begin}'
                                   end='${param.end}'
                                  step='${param.step}'>
              <c:out value='${item}'/>
         </c:forEach>
      </c:catch>

      <%-- Because this form does not specify an action, this
           JSP page will be reloaded when the submit button
           is activated --%>
      <form>
         <table>
            <tr>
               <td>Begin:</td>
               <td><input type='text' size='3' 
                         value='<c:out value="${param.begin}"/>'
                          name='begin'/>
               </td>
            
               <td>End:</td>
               <td><input type='text' size='3'
                         value='<c:out value="${param.end}"/>'
                          name='end'/>
               </td>
            
               <td>Step:</td>
               <td><input type='text' size='3'
                         value='<c:out value="${param.step}"/>'
                          name='step'/>
               </td>
            </tr>
         </table>

         <p><input type='submit' value='Iterate Now'/>
      </form>

      <%-- Handle exceptions thrown by <c:forEach> --%>
      <c:if test='${not empty exception}'>
         <font color='red'>
            Iteration failed because<i> 
            <c:out value='${exception.message}'/></i>
         </font>
      </c:if>
   </body>
</html>
