package tags;

import java.io.Reader;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.*;

public class DisplayUrlAction extends TagSupport {
   private String readerName;
   
   public void setReader(String readerName) {
      this.readerName = readerName;
   }
   public int doStartTag() throws JspException {
      int character;

      Reader reader = (Reader)
                       pageContext.findAttribute(readerName);

      if(reader == null) {
         throw new JspException("You can only use this action " +
                                "in the body of a "  +
                                "&lt;c:import&gt; "  +
                                "action that exposes a reader ");
      }
      try {
         while((character = reader.read()) != -1)
            pageContext.getOut().print((char)character);
      }
      catch(java.io.IOException ex) {
         throw new JspException(ex.getMessage());
      }
      return SKIP_BODY;
   }
}
