<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Using &lt;c:redirect&gt;</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>

      <%-- Define a prefix variable for readability --%>
      <c:set var='prefix'
         value='http://www.javaworld.com/javaworld/'/>

      <%-- The base URL for the overview article --%>
      <c:set var='overview'
       value='${prefix}jw-10-2001/jw-1012-designpatterns_p.html'/>

      <%-- The base URL for the strategy article --%>
      <c:set var='strategy'
       value='${prefix}jw-04-2002/jw-0426-designpatterns_p.html'/>

      <%-- The base URL for the decorator article --%>
      <c:set var='decorator'
       value='${prefix}jw-12-2001/jw-1214-designpatterns_p.html'/>

      <%-- The base URL for the proxy article --%>
      <c:set var='proxy'
       value='${prefix}jw-02-2002/jw-0222-designpatterns_p.html'/>

      <%-- The base URL for the composite article --%>
      <c:set var='composite'
       value='${prefix}jw-12-2001/jw-1228-jsptemplate_p.html'/>

      <%-- The encoded URL for the overview article --%>
      <c:url var='overviewUrl' value='log_access.jsp'>
         <c:param name='page' value='${overview}'/>
         <c:param name='name' value='Design Patterns Overview'/>
      </c:url>

      <%-- The encoded URL for the strategy article --%>
      <c:url var='strategyUrl' value='log_access.jsp'>
         <c:param name='page' value='${strategy}'/>
         <c:param name='name' value='Strategy Design Pattern'/>
      </c:url>

      <%-- The encoded URL for the decorator article --%>
      <c:url var='decoratorUrl' value='log_access.jsp'>
         <c:param name='page' value='${decorator}'/>
         <c:param name='name' value='Decorator Design Pattern'/>
      </c:url>

      <%-- The encoded URL for the proxy article --%>
      <c:url var='proxyUrl' value='log_access.jsp'>
         <c:param name='page' value='${proxy}'/>
         <c:param name='name' value='Proxy Design Pattern'/>
      </c:url>

      <%-- The encoded URL for the composite article --%>
      <c:url var='compositeUrl' value='log_access.jsp'>
         <c:param name='page' value='${composite}'/>
         <c:param name='name' value='Composite Design Pattern'/>
      </c:url>

      <font size='5'>
         Here are some JavaWorld articles on Java Design Patterns:
      </font><p>

      <%-- Links to articles with URLs created above --%>
      <a href='<c:out value="${overviewUrl}"/>'>
         Java Design Patterns Overview
      </a><p>
      <a href='<c:out value="${strategyUrl}"/>'>
         The Strategy Design Pattern
      </a><p>
      <a href='<c:out value="${decoratorUrl}"/>'>
         The Decorator Design Pattern
      </a><p>
      <a href='<c:out value="${proxyUrl}"/>'>
         The Proxy Design Pattern
      </a><p>
      <a href='<c:out value="${compositeUrl}"/>'>
         J2EE Composite View Pattern
      </a>
   </body>
</html>
