package tags;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import javax.servlet.http.*;

import javax.servlet.jsp.jstl.core.Config;
import javax.servlet.jsp.jstl.fmt.LocalizationContext;

public class ShowConfigSettingsTag extends TagSupport {
   private static String[] settings = {
      Config.FMT_LOCALE,              Config.FMT_FALLBACK_LOCALE,
      Config.FMT_LOCALIZATION_CONTEXT,Config.FMT_TIME_ZONE,
      Config.SQL_DATA_SOURCE,         Config.SQL_MAX_ROWS
   };

   public int doStartTag() throws JspException {
      try {
         JspWriter out = pageContext.getOut();

         out.print("JSTL Configuration Settings:<p><ul>");

         for(int i=0; i < settings.length; ++i) {
            String name = settings[i];
            Object o = Config.find(pageContext, name);
            out.print("<li><b>" + name + "</b>: "); 

            if(o == null)
               out.print("null<br>");
            else {
               if(name.equals(Config.FMT_LOCALIZATION_CONTEXT)) {
                  // Like all JSTL configuration settings, the
                  // FMT_LOCALIZATION_CONTEXT setting can be
                  // specified with a string...
                  if(o instanceof java.lang.String)
                     out.println(o);
                  else {
                     LocalizationContext lc = 
                                         (LocalizationContext)o;
                     out.print("<ul><li>Resource Bundle: ");
                     out.println(lc.getResourceBundle());
                     out.print("<li>Locale: ");
                     out.println(lc.getLocale() + "</ul>");
                  }
               }
               else {
                  out.print(o);
               }
            }
         }
         out.print("</ul></ul>");
      }
      catch(java.io.IOException ex) {
         throw new JspException(ex.getMessage());
      }
      return SKIP_BODY;
   }
}
