<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ taglib uri='http://java.sun.com/jstl/fmt'  prefix='fmt'%>
      <%@ taglib uri='http://java.sun.com/jstl/fmt_rt'
              prefix='fmt_rt' %>

      <%-- set_locale.jsp sets the locale according to the locale
           request parameter that is set by flags.jsp, which is
           imported below. set_locale.jsp uses <fmt:setLocale>--%>
      <c:import url='set_locale.jsp'/>
      
      <%-- Establish a localization context (based on the locale
           set by set_locale.jsp and the bundle base name specified
           for <fmt:setBundle>) used by subsequent <fmt:message> 
           actions. Because the locale set by set_locale.jsp is 
           used to establish that localization context, 
           set_locale.jsp must be imported before 
           <fmt:setBundle> is used. --%>
      <fmt:setBundle basename='app'/>

      <title><fmt:message key='page.title'/></title>
   </head>

   <body>
      <c:import url='flags.jsp'/><br/>

      <%-- All of the <fmt:message> actions that follow will
           use the resource bundle determined by the 'app'
           bundle basename and the locale that was last selected
           by clicking on a flag. --%>

      <fmt:message key='message.diskFull'>
         <%-- Specify the parameter for the disk number
              in the body of the <fmt:param> action --%>
         <fmt:param>
            5
         </fmt:param>

         <%-- Specify the parameter for the date
              with the <fmt_rt:param> action's value 
              attribute --%>
         <fmt_rt:param value='<%= new java.util.Date() %>'/>
      </fmt:message>
   </body>
</html>
