<%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
<%@ taglib uri='http://java.sun.com/jstl/fmt' prefix='fmt'%>

<%-- If the request attribute "validateError" exists --%>
<c:if test='${requestScope.validateError != null}'>

   <%-- The following scriplet performs these steps:
   	1. Obtain a reference to the validation error.
   	2. Store the error's keys in page scope.
   	3. Store the error's bundle basename in page scope. --%>

   	<% beans.ValidationError error = (beans.ValidationError)
                           request.getAttribute("validateError");

      	pageContext.setAttribute("errors", error.getErrorKeys());
      	pageContext.setAttribute("bundleBasename", 
                              	  error.getBundleBasename());
   %>

   <%-- Set the bundle basename for all <fmt:message> actions
        within the body of the <fmt:bundle> action --%>
   <fmt:bundle basename='${bundleBasename}'>
      <%-- For each error key ...--%>
      <c:forEach var='key' items='${errors}' 
           varStatus='status'>

         <c:choose>
            <%-- If it's the first key ...--%>
            <c:when test='${status.first}'>
               <font color='red'>
                  <fmt:message key='${key}'/>
                  <ul>
            </c:when>

            <%-- If it's the last key ...--%>
            <c:when test='${status.last}'>
                     <li><fmt:message key='${key}'/></li>
                  </ul>
               </font>
            </c:when>

            <%-- If it's not the first or last key ...--%>
            <c:otherwise>
                     <li><fmt:message key='${key}'/></li>
            </c:otherwise>
         </c:choose>
      </c:forEach>
   </fmt:bundle>
</c:if>
