package tags;

import java.util.Vector;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;

import javax.servlet.jsp.jstl.fmt.LocaleSupport;

import beans.ValidationError;

public class ShowValidateErrorTag extends TagSupport {
   public int doEndTag() throws JspException {
      // Retrieve the validate-error scoped variable, which
      // is an instance of ValidationError
      ValidationError err = 
                     (ValidationError)pageContext.getRequest().
                      getAttribute("validateError");
      if(err != null) {
         // Get error keys from the ValidationError
         Vector errorKeys = err.getErrorKeys();

         // Get the size of the errorKeys vector
         int numberOfKeys = errorKeys.size();

         // Get the bundle basename from the ValidationError
         String bundleBasename = err.getBundleBasename();

         // Write output to this JspWriter
         JspWriter out = pageContext.getOut();

         // For each error key ...
         for(int i=0; i < errorKeys.size(); ++i) {
            try {
               // Retrieve the localized message
               String msg = LocaleSupport.getLocalizedMessage(
                            pageContext, (String)errorKeys.get(i),
                            bundleBasename);
         
               // If it's the first key ...
               if(i == 0) {
                     out.print("<font color='red'>");
                     out.print(msg + "<br/><ul>");
               }
               else { // All but the first key ...
                     out.print("<li>" + msg + "</li>");
               }

               // If it's the last key ...
               if(i == numberOfKeys-1) {
                     pageContext.getOut().print("</font></ul>");
               }
            }
            catch(java.io.IOException ex) {
                  throw new JspException(ex.getMessage());
            }
         }
      }
      return EVAL_PAGE;
   }
}
