<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <%-- Set the charset to UTF-8 for multiple language 
           support --%>
      <%@ page contentType='text/html; charset=UTF-8' %>

      <%@ taglib uri='http://java.sun.com/jstl/fmt'  prefix='fmt'%>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'%>

      <%-- set_locale.jsp sets the locale according to the locale
           request parameter that is set by flags.jsp, which is
           imported below. set_locale.jsp uses <fmt:setLocale>--%>
      <c:import url='set_locale.jsp'/>

      <%-- Establish a localization context (based on the locale
           set by set_locale.jsp and the bundle basename specified
           for <fmt:setBundle>) used by subsequent <fmt:message> 
           actions. Because the locale set by set_locale.jsp is 
           used to establish that localization context, 
           set_locale.jsp must be imported before 
           <fmt:setBundle> is used. --%>
      <fmt:setBundle basename='app'/>

      <%-- Use <fmt:message> to show the page title --%>
      <title><fmt:message key='login.page.title'/></title>
   </head>

   <body>
      <%-- flags.jsp shows the flags --%>
      <c:import url='flags.jsp'/><br>

      <%-- All of the <fmt:message> actions that follow will
           use the resource bundle determined by the 'app'
           bundle basename and the locale that was last selected
           by clicking on a flag. Initially, that locale is
           set by the javax.servlet.jsp.jstl.fmt.locale
           context init param in WEB-INF/web.xml. --%>

      <fmt:message key='login.form.title'/><hr/>

      <form method='post'>
         <table>
            <tr><td><fmt:message key='login.textfield.name'/></td>
                <td><input type='text' name='userName'/></td> 
            </tr>
            <tr> 
                <td><fmt:message key='login.textfield.pwd'/></td>
                <td><input type='password' name='password'/></td>
            </tr>
         </table><br/>

         <input type='submit' 
               value='<fmt:message key="login.button.submit"/>'/>
      </form>
   </body>
</html>
