<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Formatting Numbers With Patterns</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ taglib uri='http://java.sun.com/jstl/core_rt'
              prefix='c_rt' %>
      <%@ taglib uri='http://java.sun.com/jstl/fmt' prefix='fmt'%>

      <%-- Set values based on request parameters --%>
      <c:choose>
         <c:when test='${empty param.value}'>
            <c:set var='value' value='1234567.4327'/>
         </c:when>
         <c:otherwise>
            <c:set var='value' value='${param.value}'/>
         </c:otherwise>
      </c:choose>

      <c:choose>
         <c:when test='${empty param.locale}'>
            <c_rt:set var='locale' 
                    value='<%= java.util.Locale.getDefault() %>'/>
         </c:when>
         <c:otherwise>
            <c:set var='locale' value='${param.locale}'/>
         </c:otherwise>
      </c:choose>

      <%-- Set the Locale --%>
      <fmt:setLocale value='${locale}'/>

      <%-- Show formatted number --%>
      <font size='5'>
         Formatted value: 
         <fmt:formatNumber value='${value}' 
                         pattern='${param.pattern}'/>
      </font>

      <%-- Because this form does not specify an action, this
           JSP page will be reloaded when the form's submit
           button is activated --%>
      <form>
         <table>
            <tr>
               <td>Format this value:</td>
               <td><input type='text' name='value'
                         value='<c:out value="${value}"/>'/>
               </td>
            </tr>

            <tr>
               <td>With this locale:</td>
               <td>
               <select name='locale'>
                  <c_rt:forEach var='thisLocale'
                              items='<%= java.text.NumberFormat.
                                         getAvailableLocales()%>'>
                     <option
                     <c:if test='${locale == thisLocale}'>
                        selected
                     </c:if>

                     <c:out value='>${thisLocale}'
                        escapeXml='false'/>
                     </option>
                  </c_rt:forEach>
               </select>
               </td>
            </tr>

            <tr>
               <td>With this pattern:</td>
               <td><input type='text' name='pattern'
                       value='<c:out value="${param.pattern}"/>'/>
               </td>
            </tr>
         </table>
         <p><input type='submit'/>
      </form>
   </body>
</html>
