<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Formatting Dates With Patterns</title>
   </head>

   <body>
      <%@ page contentType='text/html; charset=UTF-8' %>

      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ taglib uri='http://java.sun.com/jstl/fmt'  prefix='fmt'%>
      <%@ taglib uri='http://java.sun.com/jstl/core_rt'
              prefix='c_rt' %>

      <%-- Create a scoped variable based on the locale
           request parameter --%>
      <c:choose>
         <c:when test='${empty param.locale}'>
            <c_rt:set var='locale' 
                    value='<%= java.util.Locale.getDefault() %>'/>
         </c:when>
         <c:otherwise>
            <c:set var='locale' value='${param.locale}'/>
         </c:otherwise>
      </c:choose>

      <%-- Set the locale according to the locale request
           parameter --%>
      <fmt:setLocale value='${locale}'/>

      <%-- Create a scoped variable that contains the current 
           date --%>
      <jsp:useBean id='now' class='java.util.Date'/>

      <%-- Show formatted number --%>
      <font size='5'>Formatted date: 
         <c:choose>
            <c:when test='${not empty param.pattern}'>
               <fmt:formatDate value='${now}' 
                             pattern='${param.pattern}'/>
            </c:when>
            <c:otherwise>
               <fmt:formatDate value='${now}'/> 
            </c:otherwise>
         </c:choose>
      </font>

      <%-- Because this form does not specify an action, this
           JSP page will be reloaded when the submit button
           is activated --%>
      <form>
         <table>
            <tr>
               <td>Format this date:</td>
               <td><c:out value='${now}'/></td>
            </tr>

            <tr>
               <td>With this locale:</td>
               <td>
               <select name='locale'>
                  <c_rt:forEach var='thisLocale'
                              items='<%= java.text.DateFormat.
                                         getAvailableLocales()%>'>
                     <option
                     <c:if test='${locale == thisLocale}'>
                        selected
                     </c:if>

                     <c:out value='>${thisLocale}'
                        escapeXml='false'/>
                     </option>
                  </c_rt:forEach>
               </select>
               </td>
            </tr>

            <tr>
               <td>With this pattern:</td>
               <td><input type='text' name='pattern' size='50'
                       value='<c:out value="${param.pattern}"/>'/>
               </td>
            </tr>
         </table>
         <p><input type='submit'/>
      </form>
   </body>
</html>
