<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Formatting Numbers</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ taglib uri='http://java.sun.com/jstl/core_rt'
              prefix='c_rt' %>
      <%@ taglib uri='http://java.sun.com/jstl/fmt' prefix='fmt'%>

      <%-- Check locale and value request parameters --%>
      <c:choose>
         <c:when test='${not empty param.locale}'>
            <c:set var='locale' value='${param.locale}'/>
         </c:when>
         <c:otherwise>
            <c_rt:set var='locale' 
                    value='<%= java.util.Locale.getDefault() %>'/>
         </c:otherwise>
      </c:choose>

      <c:choose>
         <c:when test='${not empty param.value}'>
            <c:set var='value' value='${param.value}'/>
         </c:when>
         <c:otherwise>
            <c:set var='value' value='12345.6789'/>
         </c:otherwise>
      </c:choose>

      <%-- <fmt:formatNumber> doesn't have a formatLocale 
           attribute, so the locale is specified with
           <fmt:setLocale> --%>
      <fmt:setLocale value='${locale}'/>

      <%-- Format the number --%>
      <font size='5'>
         After Formatting:
         <fmt:formatNumber value='${value}'
                minIntegerDigits='${param.minIntDig}'
                maxIntegerDigits='${param.maxIntDig}'
               minFractionDigits='${param.minFrDig}'
               maxFractionDigits='${param.maxFrDig}'
                    groupingUsed='${param.groupingUsed}'/>
      </font>

      <%-- Because this form does not specify an action, this
           JSP page will be reloaded when the form's submit
           button is activated --%>
      <form>
         <table>
            <tr>
               <td>Format this value:</td>
               <td><input type='text' 
                         value='<c:out value="${value}"/>'
                          name='value'/>
               </td>
            </tr>
            <tr>
               <td>With this locale:</td>
               <td>
               <select name='locale'>
                  <c_rt:forEach var='formatLocale'
                              items='<%= java.text.NumberFormat.
                                         getAvailableLocales()%>'>
                     <option
                     <c:if test='${locale == formatLocale}'>
                        selected
                     </c:if>

                     ><c:out value='${formatLocale}'/>
                     </option>
                  </c_rt:forEach>
               </select>
               </td>
            </tr>
            <tr>
               <td>Minimum Integer Digits:</td>
               <td>
               <select name='minIntDig'>
                  <c:forEach items='0,1,2,3,4,5,6,7,8,9,10'
                               var='minIntDig'>
                     <option
                     <c:if test='${param.minIntDig == minIntDig}'>
                        selected
                     </c:if>

                     ><c:out value='${minIntDig}'/>
                     </option>
                  </c:forEach>
                  </select>
               </td>
            </tr>
            <tr>
               <td>Maximum Integer Digits:</td>
               <td>
               <select name='maxIntDig'>
                  <c:forEach items='0,1,2,3,4,5,6,7,8,9,10,40'
                               var='maxIntDig'>
                     <option
                     <c:if test='${param.maxIntDig == maxIntDig}'>
                        selected
                     </c:if>

                     ><c:out value='${maxIntDig}'/>
                     </option>
                  </c:forEach>
                  </select>
               </td>
            </tr>
            <tr>
               <td>Minimum Fraction Digits:</td>
               <td>
               <select name='minFrDig'>
                  <c:forEach items='0,1,2,3,4,5,6,7,8,9,10'
                               var='minFrDig'>
                     <option
                     <c:if test='${param.minFrDig == minFrDig}'>
                        selected
                     </c:if>

                     ><c:out value='${minFrDig}'/>
                     </option>
                  </c:forEach>
                  </select>
               </td>
            </tr>
            <tr>
               <td>Maximum Fraction Digits:</td>
               <td>
               <select name='maxFrDig'>
                  <c:forEach items='0,1,2,3,4,5,6,7,8,9,10,40'
                               var='maxFrDig'>
                     <option
                     <c:if test='${param.maxFrDig == maxFrDig}'>
                        selected
                     </c:if>

                     ><c:out value='${maxFrDig}'/>
                     </option>
                  </c:forEach>
                  </select>
               </td>
            </tr>
            <tr>
               <td>Grouping Used:</td>
               <td>
               <select name='groupingUsed'>
                  <c:forEach items='true,false' var='groupingUsed'>
                     <option
                     <c:if 
                      test='${param.groupingUsed == groupingUsed}'>
                        selected
                     </c:if>

                     ><c:out value='${groupingUsed}'/>
                     </option>
                  </c:forEach>
                  </select>
               </td>
            </tr>
         </table>
         <p><input type='submit'/>
      </form>
   </body>
</html>
