<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>TimeZone Converter</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c' %>
      <%@ taglib uri='http://java.sun.com/jstl/fmt'  prefix='fmt'%>
      <%@ taglib uri='http://java.sun.com/jstl/core_rt'
              prefix='c_rt' %>

      <%-- These classes are needed below --%>
      <%@ page import='java.util.TimeZone' %>
      <%@ page import='java.util.Date' %>
      <%@ page import='java.util.Locale' %>
      <%@ page import='javax.servlet.jsp.jstl.core.Config' %>

      <%-- Set the locale to U.S. English --%>
      <fmt:setLocale value='en-US'/>

      <%-- Use this bean below --%>
      <jsp:useBean id='now' class='java.util.Date'/>

      <%-- Store the default time zone in a scoped variable --%>
      <c_rt:set value='<%= TimeZone.getDefault() %>'
                 var='defaultTimeZone'/>

      <%-- Store the name of the default time zone in a 
           scoped variable --%>
      <c_rt:set value='<%= TimeZone.getDefault().
                           getDisplayName(Locale.US) %>' 
                 var='defaultTimeZoneName'/>

      <%-- Store all available time zone Standard IDs in 
           a scoped variable --%>
      <c_rt:set value='<%= TimeZone.getAvailableIDs() %>' 
                 var='availableTimeZones'/>

      <%-- Because this form does not specify an action, this
           JSP page will be reloaded when the form's submit
           button is activated --%>
      <form>
         <%-- Create the HTML SELECT element for selecting a
              time zone --%>
         <select name='timeZone'>
            <%-- For each available time zone --%>
            <c:forEach var='item' items='${availableTimeZones}'>
               <option
               <c:choose>
                  <%-- If no time zone was previously selected --%>
                  <c:when test='${empty param.timeZone}'>
                     <%-- Select this option if it's equal to
                          the default time zone --%>
                     <c_rt:if test='<%= TimeZone.getDefault().
                            equals(TimeZone.getTimeZone((String)
                            Config.find(pageContext, "item")))%>'>
                        selected
                     </c_rt:if>
                  </c:when>

                  <%-- Select this option if it equals the last
                       time zone selected --%>
                  <c:when test='${param.timeZone == item}'>
                     selected
                  </c:when>
               </c:choose>

               ><c:out value='${item}'/></option>
            </c:forEach>
         </select>
         <input type='submit'/>   
      </form>

      <%-- Display the current date and time in the JSP container's
           time zone --%>
      Current Date and Time in Your Server's TimeZone<i>
      (<c:out value='${defaultTimeZoneName}'/>)</i>:

      <fmt:formatDate value='${now}' type='both'
                   timeZone='${defaultTimeZone}'/><br>

      <c:choose>
         <%-- If a time zone was previously selected, show
              the date and time for that time zone --%>
         <c:when test='${not empty param.timeZone}'>
            Current Date and Time in the 
            <i><c:out value=' ${param.timeZone} TimeZone: '/></i>
            <fmt:timeZone value='${param.timeZone}'>
               <fmt:formatDate value='${now}' type='both'/>
            </fmt:timeZone>
         </c:when>
      </c:choose>
   </body>
</html>
