<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Custom SQL Parameter Actions</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'  %>
      <%@ taglib uri='http://java.sun.com/jstl/sql'  prefix='sql'%>
      <%@ taglib uri='WEB-INF/app-tlds/sql.tld'
              prefix='core-jstl'%>

      <%-- This query is made to find out how many customers
           are currently in the database --%>
      <sql:query var='customers'>
         SELECT * FROM CUSTOMERS   
      </sql:query>

      <%-- Perform the database update --%>
      <sql:update var='updateResult'> 
         INSERT INTO CUSTOMERS VALUES (?, ?, ?, ?, ?, ?)
         <sql:param value='${customers.rowCount+1}'/>

         <%-- The <core-jstl:nameParam> custom action coallasces 
              the first and last names (which are request 
              parameters) and passes them to it's enclosing 
              <sql:update> action --%>
         <core-jstl:nameParam/>

         <sql:param value='${param.phone}'/>
         <sql:param value='${param.address}'/>
         <sql:param value='${param.city}'/>
         <sql:param value='${param.state}'/>
      </sql:update>

      <%-- Show the result of the update --%>
      <font size='5'>
         <c:out value='${updateResult} Customer was Inserted:'/>
         <c:out value='${param.name}'/>
      </font>

      <%-- After adding a customer, retry the customers query --%>
      <sql:query var='customers'>
         SELECT * FROM CUSTOMERS   
      </sql:query>

      <%-- Access the rowCount property of the query --%>
      <p>There are <c:out value='${customers.rowCount}'/> rows
       in the customer query. Here they are:

      <%-- Create a table with column metadata and row data --%>
      <p><table border='1'>
         <tr>
            <c:forEach var='columnName' 
                     items='${customers.columnNames}'>
               <th><c:out value='${columnMetaData.name}'/></th>
            </c:forEach>
           </tr> 
         <c:forEach var='row' items='${customers.rowsByIndex}'>
             <tr>
               <c:forEach var='rowData' items='${row}'>
                  <td><c:out value='${rowData}'/></td>
               </c:forEach>
             </tr>
         </c:forEach>
      </table>
   </body>
</html>
