<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Using SQL Date Parameters</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'  %>
      <%@ taglib uri='http://java.sun.com/jstl/sql'  prefix='sql'%>
      <%@ taglib uri='http://java.sun.com/jstl/fmt'  prefix='fmt'%>

      <%-- Parse the date request parameter into a
           java.util.Date object and store it in a scoped 
           variable in page scope --%>
      <fmt:parseDate var='javaDate' value='${param.date}' 
               dateStyle='short'/>

      <font size='5'>
         Orders for <c:out value='${param.date}'/>:
      </font>

      <%-- Select orders placed on the date specified by the
           request parameter --%>
      <sql:query var='orders'> 
         SELECT * FROM Orders JOIN Customers 
         WHERE Orders.Order_Date = ? AND
         Customers.Cust_ID = Orders.Cust_ID

         <%-- You can't just specify a Java date with <sql:param>,
              like this...
         <sql:param value='${javaDate}'/> --%>

         <%-- ...instead, you have to use <sql:dateParam>: --%>
         <sql:dateParam value='${javaDate}' type='date'/>
      </sql:query>

      <%-- Display the query results --%>
      <p><table border='1'>
         <tr>
            <th>CUST_ID</th>
            <th>NAME</th>
            <th>ORDER_NUMBER</th>
            <th>ORDER_DATE</th>
            <th>AMOUNT</th>
            <th>DESCRIPTION</th>
          </tr> 

         <c:forEach var='row' items='${orders.rows}'>
            <fmt:formatNumber var='amount' type='currency'>
               <c:out value='${row.AMOUNT}'/>
            </fmt:formatNumber>
            <tr>
               <td><c:out value='${row.Cust_ID}'/></td>
               <td><c:out value='${row.Name}'/></td>
               <td><c:out value='${row.Order_Number}'/></td>
               <td><c:out value='${row.Order_Date}'/></td>
               <td><c:out value='${amount}'/></td>
               <td><c:out value='${row.Description}'/></td>
             </tr>
         </c:forEach>
      </table>
   </body>
</html>
