<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Updating a Database: DELETE</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'  %>
      <%@ taglib uri='http://java.sun.com/jstl/sql'  prefix='sql'%>

      <%-- Perform the database delete --%>
      <sql:update var='updateResult'> 
         DELETE FROM CUSTOMERS WHERE NAME = ?
         <sql:param value='${param.customer}'/>
      </sql:update>

      <%-- Show how many rows were deleted --%>
      <font size='5'>
         <c:out value='${updateResult} Customer was Deleted:'/>
         <c:out value='${param.customer}'/>
      </font>

      <%-- Make a query of all customers in the database --%>
      <sql:query var='customers'>
         SELECT * FROM CUSTOMERS   
      </sql:query>

      <%-- Access the rowsCount property of the query --%>
      <p><c:out value='There are ${customers.rowCount} rows'/>
       in the customer query. Here they are:

      <%-- Create a table with column metadata and row data --%>
      <p><table border='1'>
         <tr>
            <c:forEach var='columnName' 
                  items='${customers.columnNames}'>
               <th><c:out value='${columnName}'/></th>
            </c:forEach>
         </tr>
         
         <c:forEach var='row' items='${customers.rowsByIndex}'>
             <tr>
               <c:forEach var='rowData' items='${row}'> 
                  <td><c:out value='${rowData}'/></td>
                </c:forEach>
            </tr>
         </c:forEach>
      </table>
   </body>
</html>
