<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'%>
      <%@ taglib uri='http://java.sun.com/jstl/sql'  prefix='sql'%>
      <title>Updating a Database: INSERT</title>
   </head>

   <body>
      <%-- This query is made to find out how many customers
           are currently in the database --%>
      <sql:query var='customers'>
         SELECT * FROM CUSTOMERS   
      </sql:query>

      <%-- Perform the database update --%>
      <sql:update var='updateResult'> 
         INSERT INTO CUSTOMERS VALUES (?, ?, ?, ?, ?, ?)
         <sql:param value='${customers.rowCount+1}'/>
         <sql:param value='${param.name}'/>
         <sql:param value='${param.phone}'/>
         <sql:param value='${param.address}'/>
         <sql:param value='${param.city}'/>
         <sql:param value='${param.state}'/>
      </sql:update>

      <%-- Show the result of the update --%>
      <font size='5'>
         <c:out value='${updateResult} Customer was Inserted:'/>
         <c:out value='${param.name}'/>
      </font>

      <%-- After adding a customer, perform another customers 
           query --%>
      <sql:query var='customers'>
         SELECT * FROM CUSTOMERS   
      </sql:query>

      <%-- Access the rowCount property of the query --%>
      <p><c:out value='There are ${customers.rowCount} rows'/>
       in the customer query. Here they are:</p>

      <%-- Create a table with column names and row data --%>
      <p><table border='1'>
         <tr>
            <c:forEach var='columnName' 
                     items='${customers.columnNames}'>
               <th><c:out value='${columnName}'/></th>
            </c:forEach>
           </tr> 

         <c:forEach var='row' items='${customers.rowsByIndex}'>
            <tr>
               <c:forEach var='rowData' items='${row}'>
                  <td><c:out value='${rowData}'/></td>
               </c:forEach>
            </tr>
         </c:forEach>
      </table>
   </body>
</html>
