<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Using SQL Parameters</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'  %>
      <%@ taglib uri='http://java.sun.com/jstl/sql'  prefix='sql'%>
      <%@ taglib uri='http://java.sun.com/jstl/fmt'  prefix='fmt'%>

      <font size='5'>
         Orders Over 
            <fmt:formatNumber type='currency'>
               <c:out value='${param.amount}'/>
            </fmt:formatNumber>
         for <c:out value='${param.customer}'/>:
      </font>

      <%-- Select orders over a specified amount for a 
           specified customer --%>
      <sql:query var='orders'> 
         SELECT * FROM Orders JOIN Customers 
         WHERE Amount > ? AND Name = ? AND 
         Customers.Cust_ID = Orders.Cust_ID

         <%-- Specify a parameter value with the value attr --%>
         <sql:param value='${param.amount}'/>

         <%-- Specify a parameter value in the body content--%>
         <sql:param>
            <c:out value='${param.customer}'/>
         </sql:param>
      </sql:query>

      <%-- Display the query results --%>
      <p><table border='1'>
         <tr>
            <th>ORDER_NUMBER</th>
            <th>CUST_ID</th>
            <th>NAME</th>
            <th>AMOUNT</th>
            <th>DESCRIPTION</th>
         </tr>
         
         <c:forEach var='row' items='${orders.rows}'>
            <fmt:formatNumber var='amount' type='currency'>
               <c:out value='${row.AMOUNT}'/>
            </fmt:formatNumber>
            <tr>
               <td><c:out value='${row.Order_Number}'/></td>
               <td><c:out value='${row.Cust_ID}'/></td>
               <td><c:out value='${row.Name}'/></td>
               <td><c:out value='${amount}'/></td>
               <td><c:out value='${row.Description}'/></td>
             </tr>
         </c:forEach>
      </table>
   </body>
</html>
