<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Executing Database Transactions</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'  %>
      <%@ taglib uri='http://java.sun.com/jstl/sql' prefix='sql'%>
      <%@ taglib uri='http://java.sun.com/jstl/fmt' prefix='fmt'%>

      <%-- Execute a query that joins the Customers and 
           Accounts tables --%>
      <sql:query var='customers' maxRows='10'> 
         SELECT Customers.Cust_ID, Customers.Name, Accounts.Balance
			FROM Customers JOIN Accounts
			WHERE Customers.CUST_ID = Accounts.CUST_ID
      </sql:query>

      <%-- Create a table with column names and row data --%>
      <p><table align='center' border='1'>
      <tr>
         <c:forEach var='column' items='${customers.columnNames}'>
            <th><c:out value='${column}'/></th>
         </c:forEach>
      </tr>
         
      <c:forEach var='row' items='${customers.rowsByIndex}'> 
         <tr>
            <c:forEach var='rowData' items='${row}'
                 varStatus='status'>
               <c:choose>
                  <c:when test='${status.count == 3}'>
                     <fmt:formatNumber var='balance'
                                     value='${rowData}'
                                      type='currency'/>

                     <td><c:out value='${balance}'/></td>
                  </c:when>
                  <c:otherwise>
                     <td><c:out value='${rowData}'/></td>
                  </c:otherwise>
               </c:choose>
            </c:forEach>
         </tr>
      </c:forEach>
      </table>
      <form action='transfer_funds.jsp'>
         <i>Transfer this amount:</i>
         <select name='amount'>
            <c:forEach var='amt' 
                     items='100,1000,10000,100000,1000000'
                     varStatus='status'>

               <fmt:formatNumber var='money' 
                               value='${amt}' type='currency'/>
               <c:out escapeXml='false' value='<option'/>
                  <c:if test='${param.amount == amt}'>
                     selected
                  </c:if>

                  <c:out value='value=${amt}'/>
                  <c:out escapeXml='false' value='>'/>
                  <c:out value='${money}'/>
               </option>
            </c:forEach>
         </select>
         <p><i>from:</i>
         <select name='fromCustomer'>
            <c:forEach var='row' items='${customers.rows}'>
               <c:out escapeXml='false' value='<option'/>
                  <c:if 
                     test='${param.fromCustomer == row.cust_id}'>
                     selected
                  </c:if>

                  <c:out value='value=${row.cust_id}'/>
                  <c:out escapeXml='false' value='>'/>
                  <c:out value='${row.name}'/>
               </option>
            </c:forEach>
         </select>
         <i>to:</i>
         <select name='toCustomer'>
            <c:forEach var='row' items='${customers.rows}'>
               <c:out escapeXml='false' value='<option'/>
                  <c:if test='${param.toCustomer == row.cust_id}'>
                     selected
                  </c:if>

                  <c:out value='value=${row.cust_id}'/>
                  <c:out escapeXml='false' value='>'/>
                  <c:out value='${row.name}'/>
               </option>
            </c:forEach>
         </select>
         <p><input type='submit' value='Transfer Funds'>
      </form>

   </body>
</html>
