<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
   <head>
      <title>Executing Database Transactions</title>
   </head>

   <body>
      <%@ taglib uri='http://java.sun.com/jstl/core' prefix='c'  %>
      <%@ taglib uri='http://java.sun.com/jstl/sql' prefix='sql'%>
      <%@ taglib uri='http://java.sun.com/jstl/fmt' prefix='fmt'%>

      <sql:query var='fromBalance'>
         SELECT BALANCE FROM ACCOUNTS WHERE CUST_ID = ? 
         <sql:param value='${param.fromCustomer}'/>
      </sql:query>

      <c:set var='fromBalance' 
           value='${fromBalance.rows[0].balance}'/>

      <sql:query var='toBalance'>
         SELECT BALANCE FROM ACCOUNTS WHERE CUST_ID = ? 
         <sql:param value='${param.toCustomer}'/>
      </sql:query>

      <c:set var='toBalance' 
           value='${toBalance.rows[0].balance}'/>

      <c:catch var='transactionException'>
         <sql:transaction>
            <sql:update>
               UPDATE ACCOUNTS SET BALANCE = ? WHERE CUST_ID = ?
                <sql:param value='${fromBalance - param.amount}'/>
                <sql:param value='${param.fromCustomer}'/>
            </sql:update>

            <sql:update>
               UPDATE BADTABLENAME 
					SET BALANCE = ? WHERE CUST_ID = ?
               <sql:param value='${toBalance + param.amount}'/>
               <sql:param value='${param.toCustomer}'/>
            </sql:update>
         </sql:transaction>
      </c:catch>

      <c:if test='${transactionException != null}'>
         <font size='4' color='red'>
            Transaction Failed! Please make sure that account
            you are withdrawing from has sufficient funds
            for the withdrawl.
         </font>
      </c:if>

      <c:import url='index.jsp'/>
   </body>
</html>
